=== debian/changelog ===
ros-indigo-rtabmap-ros (0.17.6-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mathieu Labbe <matlabbe@gmail.com>  Sat, 29 Sep 2018 19:29:43 -0000
