=== debian/control ===
Source: ros-indigo-rtabmap-ros
Section: misc
Priority: extra
Maintainer: Mathieu Labbe <matlabbe@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libpcl-1.7-all-dev, ros-indigo-catkin, ros-indigo-class-loader, ros-indigo-costmap-2d, ros-indigo-cv-bridge, ros-indigo-dynamic-reconfigure, ros-indigo-eigen-conversions, ros-indigo-find-object-2d, ros-indigo-genmsg, ros-indigo-geometry-msgs, ros-indigo-image-geometry, ros-indigo-image-transport, ros-indigo-laser-geometry, ros-indigo-message-filters, ros-indigo-message-generation, ros-indigo-move-base-msgs, ros-indigo-nav-msgs, ros-indigo-nodelet, ros-indigo-octomap-msgs, ros-indigo-pcl-conversions, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-rtabmap, ros-indigo-rviz, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-stereo-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-tf2-ros, ros-indigo-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-rtabmap-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-class-loader, ros-indigo-compressed-depth-image-transport, ros-indigo-compressed-image-transport, ros-indigo-costmap-2d, ros-indigo-cv-bridge, ros-indigo-dynamic-reconfigure, ros-indigo-eigen-conversions, ros-indigo-find-object-2d, ros-indigo-geometry-msgs, ros-indigo-image-geometry, ros-indigo-image-transport, ros-indigo-laser-geometry, ros-indigo-message-filters, ros-indigo-message-runtime, ros-indigo-move-base-msgs, ros-indigo-nav-msgs, ros-indigo-nodelet, ros-indigo-octomap-msgs, ros-indigo-pcl-conversions, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-rtabmap, ros-indigo-rviz, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-stereo-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-tf2-ros, ros-indigo-visualization-msgs
Description: RTAB-Map's ros-pkg.
 RTAB-Map is a RGB-D SLAM approach with real-time constraints.
